Closed Bug 1158047 Opened 5 years ago Closed 5 years ago

[Nexus5][Settings] USB storage can't be recognized by PC.

Categories

(Firefox OS Graveyard :: MTP/UMS, defect, major)

ARM
Gonk (Firefox OS)
defect
Not set
major

Tracking

(blocking-b2g:2.5?, firefox40 fixed, b2g-v2.2 unaffected, b2g-master verified)

VERIFIED FIXED
2.2 S12 (15may)
blocking-b2g 2.5?
Tracking Status
firefox40 --- fixed
b2g-v2.2 --- unaffected
b2g-master --- verified

People

(Reporter: yi.zou, Assigned: alchen)

References

Details

(Whiteboard: [v2.2-nexus-5-l])

Attachments

(3 files, 1 obsolete file)

Attached file logcat_1613.txt
[1.Description]:
[Nexus5 v3.0][Settings] Launch settings app.Then turn on USB storage, and select MTP in transfer protocol. USB has been plugged in on PC. But USB storage can't be recognized by PC.
Time:16:13
See attachment logcat_1613.txt and 1613.mp4

[2.Testing Steps]: 
1.Launch settings app.
2.Turn on USB storage, and select MTP in transfer protocol.
3.USB plugged in on PC.

[3.Expected Result]: 
3.Device storage could  be recognized by PC.

[4.Actual Result]: 
3.Device storage can't be recognized by PC.

[5.Reproduction build]: 
Flame 2.2 version(Unaffected):
Build ID               20150423002502
Gaia Revision          b838d0e7c163e66660dcb6e387d8339944a7a30e
Gaia Date              2015-04-23 02:32:46
Gecko Revision         https://hg.mozilla.org/releases/mozilla-b2g37_v2_2/rev/8dce56574f28
Gecko Version          37.0
Device Name            flame
Firmware(Release)      4.4.2
Firmware(Incremental)  eng.cltbld.20150423.035703
Firmware Date          Thu Apr 23 03:57:16 EDT 2015
Bootloader             L1TC000118D0

Flame 3.0 version(Unaffected):
Build ID               20150423160207
Gaia Revision          0c5e2ee1173f3c53379ef3cd10de714836258fe8
Gaia Date              2015-04-23 16:10:10
Gecko Revision         https://hg.mozilla.org/mozilla-central/rev/22a157f7feb7
Gecko Version          40.0a1
Device Name            flame
Firmware(Release)      4.4.2
Firmware(Incremental)  eng.cltbld.20150423.193607
Firmware Date          Thu Apr 23 19:36:18 EDT 2015
Bootloader             L1TC000118D0

Nexus5 2.2 version(Unaffected):
Build ID               20150423002502
Gaia Revision          b838d0e7c163e66660dcb6e387d8339944a7a30e
Gaia Date              2015-04-23 02:32:46
Gecko Revision         https://hg.mozilla.org/releases/mozilla-b2g37_v2_2/rev/8dce56574f28
Gecko Version          37.0
Device Name            hammerhead
Firmware(Release)      5.1
Firmware(Incremental)  eng.cltbld.20150423.035409
Firmware Date          Thu Apr 23 03:54:27 EDT 2015
Bootloader             HHZ12f

Nexus5 3.0 version(Affected):
Build ID               20150423160207
Gaia Revision          0c5e2ee1173f3c53379ef3cd10de714836258fe8
Gaia Date              2015-04-23 16:10:10
Gecko Revision         https://hg.mozilla.org/mozilla-central/rev/22a157f7feb7
Gecko Version          40.0a1
Device Name            hammerhead
Firmware(Release)      5.1
Firmware(Incremental)  eng.cltbld.20150423.192918
Firmware Date          Thu Apr 23 19:29:36 EDT 2015
Bootloader             HHZ12f

[6.Reproduction Frequency]: 
Always Recurrence,10/10

[7.TCID]: 
Free Test

[8.Note]:
The bug can be repro on Mac and Ubuntu, Windows7
Attached video 1613.mp4
Flags: needinfo?(ashiue)
We do a regression window wanted, and have narrowed the scope using nightly build, please see the below information. And we will continue doing b2g-inboud regression windows next week, but if someone can help with this, please help to do it in advance. Hope these information can helpfull. Thanks. 

20150421010201 (unaffected)
20150421160203 (affected)
[Blocking Requested - why for this release]:
Regression bug, basic function cannot work
blocking-b2g: --- → 3.0?
QA Whiteboard: [COM=MTP/UMS]
Component: Gaia::Settings → MTP/UMS
Flags: needinfo?(ashiue)
Alphan, please help check the bug. Thanks.
Flags: needinfo?(alchen)
See Also: → 1152154
From log, automounter is in a weird mode. (ums Active state is weird, should be 1 or 0)
The automounter state stay in "UMS_CONFIGURING".
I will try to flash the image on Nexus 5 and check the status.


04-24 16:11:49.349 I/AutoMounter(  197): UpdateState: ums:A138C0E0 mtp:A1C0E1 mode:3 usb:1 tryToShare:0 state:UMS_CONFIGURING

04-24 16:13:25.014 I/AutoMounter(  197): UpdateState: ums:A211C0E0 mtp:A1C0E1 mode:3 usb:0 tryToShare:0 state:UMS_CONFIGURING

04-24 08:34:41.580 I/AutoMounter(  197): UpdateState: ums:A165C0E0 mtp:A1C0E0 mode:0 usb:1 tryToShare:0 state:UMS_CONFIGURING

04-24 08:34:41.580 I/AutoMounter(  197): UpdateState: ums:A20C0E0 mtp:A1C0E0 mode:0 usb:1 tryToShare:0 state:UMS_CONFIGURING
Flags: needinfo?(alchen)
Mozilla-inbound regression window
Last Working Environmental Variables
Device Nexus 5
Build ID               20150421133006
Gaia Revision          0645bbed4d6cbd8064652eebafe011edc3e417fd
Gaia Date              2015-04-21 02:55:48
Gecko Revision         https://hg.mozilla.org/integration/mozilla-inbound/rev/8b99d282cd87
Gecko Version          40.0a1
Device Name            hammerhead
Firmware(Release)      5.1
Firmware(Incremental)  eng.cltbld.20150421.120212
Firmware Date          Tue Apr 21 12:02:29 EDT 2015
Bootloader             HHZ12f

First Broken Environmental Variables
Device Nexus 5
Build ID               20150421163005
Gaia Revision          15134b080b5f406e5aa36f5136c17dafb4e31f64
Gaia Date              2015-04-21 19:52:45
Gecko Revision         https://hg.mozilla.org/integration/mozilla-inbound/rev/e01af01b7015
Gecko Version          40.0a1
Device Name            hammerhead
Firmware(Release)      5.1
Firmware(Incremental)  eng.cltbld.20150421.120212
Firmware Date          Tue Apr 21 12:02:29 EDT 2015
Bootloader             HHZ12f

First Broken Gaia & Last Working Gecko - issue DOES NOT repro
Gaia 	15134b080b5f406e5aa36f5136c17dafb4e31f64
Gecko 	8b99d282cd87

First Broken Gecko & Last Working Gaia - issue DOES repro
Gaia 	0645bbed4d6cbd8064652eebafe011edc3e417fd
Gecko 	e01af01b7015
Hi Ben,

Could you check again according to comment 6? 
Thanks :)
Flags: needinfo?(btian)
Alphan, please help on this bug.
Assignee: nobody → alchen
Flags: needinfo?(alchen)
Flags: needinfo?(btian)
Hi Dave,
please review this patch.

In this bug, automounter stuck in UMS_CONFIGURING state, even when user change the mode to MTP.

So I move the checking of "mtpEnabled" outside to be a standalone judgement.
Besides, umsAvail initialization is missing.
I patch the fix as well.
Flags: needinfo?(alchen)
Attachment #8598405 - Flags: review?(dhylands)
Comment on attachment 8598405 [details] [diff] [review]
Resolve the problem of stucking in UMS_CONFIGURING state

Review of attachment 8598405 [details] [diff] [review]:
-----------------------------------------------------------------

Looks good and everything seems to still work properly with some testing.

Just one change that I suggested.

::: dom/system/gonk/AutoMounter.cpp
@@ +859,5 @@
> +        // MTP was enabled. Start reconfiguring.
> +        SetState(STATE_MTP_CONFIGURING);
> +        SetUsbFunction(USB_FUNC_MTP);
> +        break;
> +      }

If you move the if (mtpEnabled) before the if (umsConfigured) then we'll eliminate calling SetState(STATE_UMS_CONFIGURED) and then immediately calling SetState(STATE_MTP_CONFIGURED)

In fact the if (umsConfigured) should be moved after the if (rndisConfigured) test as well.

That way SetState will only be called exactly once.

@@ +1118,5 @@
>  void AutoMounter::GetStatus(bool& umsAvail, bool& umsConfigured, bool& umsEnabled,
>                              bool& mtpAvail, bool& mtpConfigured, bool& mtpEnabled,
>                              bool& rndisConfigured)
>  {
> +  umsAvail = false;

good catch
Attachment #8598405 - Flags: review?(dhylands) → review+
Keywords: checkin-needed
https://hg.mozilla.org/mozilla-central/rev/f16a1e24dbcd
Status: NEW → RESOLVED
Closed: 5 years ago
Resolution: --- → FIXED
Target Milestone: --- → 2.2 S12 (15may)
Verified on 

Build ID               20151021064220
Gaia Revision          32d827a70af90a05918f234e5b16b35d5d2a07e8
Gaia Date              2015-10-20 20:57:29
Gecko Revision         https://hg.mozilla.org/mozilla-central/rev/473aefe5bd85842eeb142e0cde8e2cd21edbf40b
Gecko Version          44.0a1
Device Name            hammerhead
Firmware(Release)      5.1
Firmware(Incremental)  eng.cltbld.20151021.104001
Firmware Date          Wed Oct 21 10:40:18 EDT 2015
Bootloader             HHZ12f
Status: RESOLVED → VERIFIED
You need to log in before you can comment on or make changes to this bug.